# Copyright (C) 2003  coven, coven@ddos.net
#
# qban is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# qban is distributed WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with qban; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

### options ###
# path to data file
set q(file) "/home/coven/eggdrop/qban.data"

# stick bans ?
# this means that if you set this to yes the ban will even exist in the chans banlist
# if the user isn't on the chan any more and the time the ban should last is up
set q(stick) "no"

# time in minutes the ban should last
set q(time) "60"

# qban version - don't change this
set q(ver) "1.1a"

# kick reason
set q(kick) "SPONSORED.BY.QBAN.$q(ver)"

### binds ###
bind join - "* *!*@*" q:join
bind dcc o qban dcc:qban

### yadda yadda ###
### CODE - DON'T change unless you know what you're doing ###
### yadda yadda ###

proc q:loadconf {} {
    global q
    if [file exist $q(file)] {
	uplevel {
	    source $q(file)
	}
    } {
	set f [open $q(file) w] 
	puts $f "set chans \"\"" 
	close $f
	uplevel {
	    source $q(file)
	}
    }
}
set chann ""

proc q:saveconf {} {
    global chans b q status
    set file [open $q(file) w]
    
    puts $file "set chans \"$chans\""  
    puts $file ""

    foreach chan [array names status] {
	puts $file "set status\($chan\) \"$status($chan)\""
    }    
	
    foreach bans [array names b] {
	puts $file "set b\($bans\) \"$b($bans)\""
    }
    close $file
}

proc dcc:qban {hand idx args} {
    global q
    set args [lindex $args 0]
    set mode [lindex $args 0]
    if {$mode == "add"} {
	q:ban:add $idx [lindex $args 1]
    } 
    if {$mode == "del"} {
	q:ban:del $idx [lindex $args 1]
    } 
    if {$mode == "list"} {
	q:ban:list $idx
    }
    if {$mode == "enable"} {
	q:ban:enable $idx [lindex $args 1]
    }     
    if {$mode == "disable"} {
	q:ban:disable $idx [lindex $args 1]
    }     
    if {$mode == "status"} {
	q:ban:status $idx [lindex $args 1]
    } 
    if {$mode == "help"} {
	q:help $idx
    }
    if {$mode == ""} {
	q:help $idx
    }
    checkfile $q(file)
}

proc q:ban:enable {qidx args} {
    global q b status chans
    set chan [lindex $args 0]
    if {[validchan $chan] == "1"} {
        set status($chan) "on"
	set chans "$chans $chan"
        putidx $qidx "[b]QBAN-ENABLE::[b] qban is now [b]enabled[b] for [b]$chan[b]"
	q:saveconf
    } else {
	putidx $qidx "[b]QBAN::[b] $chan is NOT a valid channel"
    }
}

proc q:ban:disable {qidx args} {
    global q b status chans
    set chan [lindex $args 0]
    if {[validchan $chan] == "1"} {    
        set status($chan) "off"
	set chans [ldelete $chans $chan]
        putidx $qidx "[b]QBAN-DiSABLE::[b] qban is now [b]disabled[b] for [b]$chan[b]"
	q:saveconf
    } else {
	putidx $qidx "[b]QBAN::[b] $chan is NOT a valid channel"
    }
}

proc b {} { return "\002" }

proc checkfile {file} {
    if {![file exists $file]} {
	putlog "file not found - new one created"
	set fileid [open $file w]
	close $fileid
    }
}

proc q:ban:status {qidx args} {
    global q b status
    set chan [lindex $args 0]
    putlog "$chan"
    if {$status($chan) == "on"} {
	set state "enabled"
    } else {
	set state "disabled"
    }
    
    if {[info exists b($chan)]} {
	set bans "$b($chan)"
    } else {
	set bans "[b]None[b]"
    }
    putidx $qidx "[b]QBAN-STATUS::[b] $chan is qban-[b]$state[b] and has the following qbans:"
    putidx $qidx "[b]QBAN-STATUS::[b] $bans"
    q:saveconf
}

proc q:ban:del {qidx args} {
    global q chans b
    set args [lindex $args 0]
    set qwho [lindex $args 1]
    set chan [lindex $args 0]
    
    set b($chan) [ldelete $b($chan) $qwho]

    putidx $qidx "[b]QBAN::[b] Removed [b]$qwho[b] from the qban list for [b]$chan[b]"
    q:saveconf
}

proc q:help {qidx} {
    putidx $qidx "[b]QBAN::[b] .qban add <chan> <authname> <-- adds a new auth to ban list"
    putidx $qidx "[b]QBAN::[b] .qban del <chan> <authname> <-- removes given auth from the ban list"
    putidx $qidx "[b]QBAN::[b] .qban status <channel> <-- shows status and bans of a channel"
    putidx $qidx "[b]QBAN::[b] .qban enable <channel> <-- enable qban for a channel"
    putidx $qidx "[b]QBAN::[b] .qban disable <channel> <-- disable qban for a channel"
    putidx $qidx "[b]QBAN::[b] .qban \[help\] <-- shows this"
}

proc q:ban:add {qidx args} {
    set args [lindex $args 0]
    global q
    if ![catch {open $q(file) a+} filelog] {
	puts $filelog "$args"
	close $filelog
	putidx $qidx "[b]QBAN::[b] Added [b]$args[b] to qban list"
    }    
}

proc q:join {nick uhost hand chan} {
    global q chans chann b status
    if {[lsearch -exact $chans $chan] != "-1"} {
	if {$status($chan) == "on"} {
    	    set q(nick) "$nick"
	    set chann "$chan"
    	    qbind
	    putserv "whois $nick"
	}
    }
}

proc raw:q330 {from key arg} {
    global q chann b
    set amessage [lindex $arg 2]

    if {info exists b($chann)} {
    foreach q_auth $b($chann) {
	if {$q_auth == $amessage} {
	    putlog "[b]QBAN[b]:: $q(nick) matched a Q auth ban: $amessage"
    	    set q(host) "$q(nick)!*[getchanhost $q(nick) $q(chann)]"
	    if {$q(stick) == "yes"} {
		newchanban $q(chann) $q(host) QBAN QBAN $q(time) sticky
	    } else {
		newchanban $q(chann) $q(host) QBAN QBAN $q(time)
	    }
	    putserv "KICK $q(chann) $q(nick) $q(kick)"
	}	
    }
    qunbind
    }
}

proc ldelete { list value } {
    set a [lsearch -exact $list $value]
    if { $a >= 0 } {
        return [lreplace $list $a $a]
    } else {
	return $list
    }
}

proc qbind { } {
    bind raw - 330 raw:q330
}

proc qunbind { } {
    unbind raw - 330 raw:q330
}

q:loadconf
putlog "QBAN $q(ver) by [b]coven[b] loaded"